#ifndef STRING_UTIL_HPP
#define STRING_UTIL_HPP

static inline int strcmp(register const char *s1, register const char *s2)
{
        while (*s1 == *s2++) {
                if (*s1++ == '\0') {
                        return 0;
                }
        }
        if (*s1 == '\0') return -1;
        if (*--s2 == '\0') return 1;
        return (unsigned char) *s1 - (unsigned char) *s2;
}

/**
 * Ansi C "itoa" based on Kernighan & Ritchie's "Ansi C":
 */	
void strreverse(char* begin, char* end);
	
void itoa(int value, char* str, int base = 10);
	

static inline char * strcpy(char * __restrict to, const char * __restrict from) /* from FREE BSD */
{
	char *save = to;
	for (; (*to = *from) != 0; ++from, ++to);
		return(save);
}
 
#endif /* STRING_UTIL_H */
