#include "../headers/interrupt_kb.h"
#include "../headers/sys.h"

unsigned int lastScanCode;
int mutex;
int num;
int caps = 0;
int scroll;
int maj;
int ctrl;
int alt;

void setNum(int _num)
{
	num = _num;
}
int getNum()
{
	return num;
}

void setCaps(int _caps)
{
	caps = _caps;
}

int getCaps()
{
	return caps;
}

void setScroll(int _scroll)
{
	scroll = _scroll;
}

int getScroll()
{
	return scroll;
}

void setMaj(int _maj)
{
	maj = _maj;
}

int getMaj()
{
	return maj;
}

void setCtrl(int _ctrl)
{
	ctrl = _ctrl;
}

int getCtrl()
{
	return ctrl;
}

void setAlt(int _alt)
{
	alt = _alt;
}

int getAlt()
{
	return alt;
}

unsigned int waitMutexAndGetValue() /* attend qu'une touche soit pressee */
{
	while (!mutex);
	mutex = 0;
	unsigned int v = lastScanCode;
	lastScanCode = '\0';
	return v;
}

/**
* ISR called by keyboard IRQ 
*/
void interruptKeyboard()
{
	do {
		lastScanCode = inb(0x64);			/* Lecture du port 0x64 */
	} while ((lastScanCode & 0x01) == 0);	/* test du bit le plus faible */

	lastScanCode=inb(0x60);				/* Un scan code est pret on le recupere dans lastScanCode */
	
	/* Traitement des touche de controles qui modifient l'�at du clavier 
		mais qui ne renvoient pas de code ascii */
	
	if (lastScanCode <= 128) { /* make codes */
			
		if (CAPS == lastScanCode) {
			caps = !caps;
			goto down_mutex;
		} else if (CTRL_LEFT == lastScanCode || CTRL_RIGHT == lastScanCode ) {
			ctrl = 1;
			goto down_mutex;
		} else if (ALT == lastScanCode) {
			alt = 1;
			goto down_mutex;
		} else if (MAJ_LEFT == lastScanCode || MAJ_RIGHT == lastScanCode) {
			maj= 1;
			goto down_mutex;
#if 0
		} 

		else if (DEL == lastScanCode) {
			if (ctrl && alt) {
				/* On appelle l'interruption 2: qui va interrompre les Threads actif et appeller exit() */
			__asm("sti");
			__asm(int 2); 
			}
#endif
		} else /* might be an ascii code */
			goto up_mutex;
	} else { /* break codes */
		
		if (BREAK_CODE(CAPS) == lastScanCode) {
			caps = !caps;
		} else if (BREAK_CODE(CTRL_LEFT) == lastScanCode || BREAK_CODE(CTRL_RIGHT) == lastScanCode) {
			ctrl = 0;
		} else if (BREAK_CODE(ALT) == lastScanCode) {
			alt = 0;
		} else if (BREAK_CODE(MAJ_LEFT) == lastScanCode || BREAK_CODE(MAJ_RIGHT) == lastScanCode) {
			maj = 0;
		}
		goto down_mutex;
	}

up_mutex:
	mutex = 1;
	return;
down_mutex:
	mutex = 0;
	return;
}
