#include "../headers/keyboard.hpp"
#include "../headers/video.hpp"

extern "C" {
	void interruptKeyboard();
	unsigned int waitMutexAndGetValue();

	void setNum(int);
	int getNum();
	
	void setMaj(int);
	int getMaj();
	
	void setCaps(int);
	int getCaps();
	
	void setCtrl(int);
	int getCtrl();
	
	void setScroll(int);
	int getScroll();

	void setAlt(int);
	int getAlt();
}

/**
* Les caractères non affichable sont définis l'aide du code ascii en octal 
* pour pouvoir utiliser la notation "abcde" commde définition de tableau.
*/
char const * Keyboard::fr_keys_min = /* A finir */
"\033" /* ESC */
"#&e\"'(-e_ca)="
"\010" /* BACK */
"\tazertyuiop^$"
"\0122" /* CTRL */
"qsdfghjklmù*"
"\0" /* MAJ gauche */
"wxcvbn,;:!"
"\0" /* MAJ Droit */
"*" /* Pavé numérique * */
"\0" /* ALT */
"\040" /* SPACE */
"\0" /* CAPS */
;

char const * Keyboard::fr_keys_maj = /* A finir également */
"\033" /* ESC */
"#1234567890)-"
"\010" /* BACK */
"\tAZERTYUIOP\"£"
"\021" /* CTRL */
"QSDFGHJKLM%²"
"\0" /* MAJ gauche */
"WXCVBN?./§"
"\0"/* MAJ Droit */
"*" /* Pavé numérique * */
"\0" /* ALT */
"\040" /* SPACE */
"\0" /* CAPS */
;

/**
* Wait for user entry. (Désolé j'ai pris l'habitude de faire mes commentaires en anglais)
*/
char Keyboard::getChar()
{
	lastScanCode = waitMutexAndGetValue(); // On attends forcément une touche ascii ici vu le traitement dans interruptKeyboard
	
	// examen de l'état du clavier
	capsEnabled = getCaps();
	majPressed = getMaj();
	numEnabled = getNum();
	scrollEnabled = getScroll();
	controlPressed = getCtrl();
	bool maj = capsEnabled ^ majPressed; // L'un ou l'autre mais les deux en meme temps annule l'effet majuscule.
	
	return capsEnabled ? keysMaj[lastScanCode] : keysMin[lastScanCode];
}
