#include "../headers/video.hpp"
#include "../headers/iostream.hpp"
//#include "../headers/cmath.hpp"
//#include "../headers/strutil.hpp"

extern "C"{
void setAdresseVideo(void * vi);
void testCPP(void * v);
void * getAdresseVideo();
}

void testCPP(void * v){
		*(static_cast<Video *>(v)) << "salut hector" <<std::endl;
}

/**
 * Initialisation des attribut par défaut, de l'adresse de la vidéo en mémoire
 * et nettoyage de l'ecran.
 */
Video::Video()
{
	this->defaultAttributes = unblink(FG_WHITE | BG_BLACK);
	this->white = unblink(BG_BLACK | FG_WHITE);
	this->red = unblink(BG_BLACK | FG_RED);
	this->green = unblink(BG_BLACK | FG_GREEN);
	this->blue = unblink(BG_BLACK | FG_BLUE);
	this->video = reinterpret_cast<char*>(0xB8000);
	this->clear();
	setAdresseVideo(static_cast<void *>(this));
}

/**
 * Nettoye l'ecran.
 */
void Video::clear() {
	for(int pos = 0; pos < 2000; pos++) {
		this->video[2 * pos] = 32;
		this->video[2 * pos + 1] = unblink(BG_BLACK | FG_WHITE);
	}
	emplacement = 0;
}

void Video::put(int n, unsigned char attributes) {
	char s[32];
	//itoa(n, s);
	for (char const *ptr = s; *ptr; ptr++) {
		put(*ptr, attributes);
	}
}

void Video::put(char const * msg, unsigned char attributes)
{
	for(; *msg; msg++)
		put(*msg, attributes);
}

void Video::put(char c, unsigned char attributes)
{
	if(static_cast<int>('\n')== static_cast<int>(c)) {
		for (; 0 != (emplacement % 80); emplacement++) {
			this->video[2 * emplacement] = 32;
			this->video[2 * emplacement + 1] = attributes;
		}
	} else if (0x0b == static_cast<int>(c)) {
		for (int i = 0; i < 4; i++, emplacement++) {
			this->video[2 * emplacement] = 32;
			this->video[2 * emplacement + 1] = attributes;
		}
	} else if (0x08 == c) {
		this->emplacement--;
		this->video[2 * emplacement] = 32;
		this->video[2 * emplacement + 1] = attributes;
	} else {
		this->video[2 * emplacement] = c;
		this->video[2 * emplacement + 1] = attributes;
		this->emplacement++;
	}
}

/**
 * Positionne le curseur clignotant au dernier emplacement
 * écrit.
 */
void Video::setCursor()
{
	this->put("_", blink(FG_PURPLE | BG_BLACK));
	this->emplacement-- ;
}

/**
 * Permet le scroll sur l'écran.
 */
void Video::Decale() /* en Construction */
{
	if(this->emplacement >= 4000) /* 80*50 */
	{
		for(int u = 0; u < 4000; u=u+50)
		{
			this->video[u] = this->video[u+50];
			this->video[u+1] = this->video[u+51];
		}
	}
	this->emplacement -= 50;
}
int Video::getEmplacement()
{
	return this->emplacement;
}

char* Video::getBufferVideo()
{
	return this->video;
}

void Video::setPixel(int num,int value)
{
	this->video[num] = value;
}

char Video::getPixel(int num){
	return this->video[num];
}

void Video::setEmplacement(int emp)
{
	this->emplacement = emp;
}
